/[gentoo-x86]/eclass/gtk-sharp-module.eclass
Gentoo

Contents of /eclass/gtk-sharp-module.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.25 - (hide annotations) (download)
Sun Aug 23 00:14:31 2009 UTC (5 years, 2 months ago) by loki_val
Branch: MAIN
Changes since 1.24: +6 -4 lines
The gnome-desktop-sharp assembly is currently locked to libgnome-desktop.so.11. Since it seems Gnome upstream will not make ABI-incompatible changes for now, we can relax dependencies. Solves bug 279072.

1 loki_val 1.1 # Copyright 1999-2008 Gentoo Foundation
2     # Distributed under the terms of the GNU General Public License v2
3 loki_val 1.25 # $Header: /var/cvsroot/gentoo-x86/eclass/gtk-sharp-module.eclass,v 1.24 2009/05/03 20:03:10 loki_val Exp $
4 loki_val 1.1
5 loki_val 1.14 # @ECLASS: gtk-sharp-module.eclass
6     # @MAINTAINER:
7     # dotnet@gentoo.org
8     # @BLURB: Manages the modules of the gtk-, gnome-, and gnome-desktop-sharp tarballs
9     # @DESCRIPTION:
10     # This eclass provides phase functions and helper functions for the modules
11     # of the gtk-sharp, gnome-sharp and gnome-desktop-sharp tarballs.
12     # PLEASE TAKE NOTE: ONLY FOR EAPI-2 EBUILDS
13 loki_val 1.1
14 loki_val 1.14 WANT_AUTOMAKE=none
15     WANT_AUTOCONF=none
16 loki_val 1.1
17 loki_val 1.24 inherit eutils mono multilib libtool autotools base versionator
18 loki_val 1.1
19 loki_val 1.14 # @ECLASS-VARIABLE: GTK_SHARP_MODULE
20     # @DESCRIPTION:
21     # The name of the Gtk# module.
22     # Default value: ${PN/-sharp/}
23 loki_val 1.1 GTK_SHARP_MODULE=${GTK_SHARP_MODULE:=${PN/-sharp/}}
24 loki_val 1.14
25     # @ECLASS-VARIABLE: GTK_SHARP_MODULE_DIR
26     # @DESCRIPTION:
27     # The subdirectory of S in which GTK_SHARP_MODULE is installed.
28     # Default value: ${PN/-sharp/}
29 loki_val 1.1 GTK_SHARP_MODULE_DIR=${GTK_SHARP_MODULE_DIR:=${PN/-sharp/}}
30    
31 loki_val 1.14 # @ECLASS-VARIABLE: GTK_SHARP_REQUIRED_VERSION
32     # @DESCRIPTION:
33     # The version of the gtk-sharp tarball this package requires.
34     # Optional.
35     GTK_SHARP_REQUIRED_VERSION="${GTK_SHARP_REQUIRED_VERSION}"
36    
37     # @ECLASS-VARIABLE: gapi_users_list
38     # @DESCRIPTION:
39     # List of modules that use one of gapi2-codegen, gapi2-fixup or gapi2-parser
40     # No ebuild-serviceable parts inside.
41     gapi_users_list="art gnome gnomevfs ${gnome_desktop_sharp_module_list} atk gtk gdk glade pango"
42    
43     # @ECLASS-VARIABLE: PV_MAJOR
44     # @DESCRIPTION:
45     # The first two components of the PV variable.
46 loki_val 1.8 PV_MAJOR=$(get_version_component_range 1-2)
47    
48 loki_val 1.21 # @FUNCTION: add_bdepend
49 loki_val 1.14 # @USAGE: <package atom>
50     # @DESCRIPTION:
51     # Adds to the DEPEND variable
52 loki_val 1.8 add_bdepend() {
53 loki_val 1.14 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
54 loki_val 1.8 DEPEND="${DEPEND} $@"
55     }
56    
57 loki_val 1.21 # @FUNCTION: add_rdepend
58 loki_val 1.14 # @USAGE: <package atom>
59     # @DESCRIPTION:
60     # Adds to the RDEPEND variable
61 loki_val 1.8 add_rdepend() {
62 loki_val 1.14 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
63 loki_val 1.8 RDEPEND="${RDEPEND} $@"
64     }
65    
66 loki_val 1.14 # @FUNCTION: add_depend
67     # @USAGE: <package atom>
68     # @DESCRIPTION:
69     # Adds to the DEPEND and RDEPEND variables
70 loki_val 1.8 add_depend() {
71 loki_val 1.14 [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs ONE (1) argument"
72 loki_val 1.8 DEPEND="${DEPEND} $@"
73     RDEPEND="${RDEPEND} $@"
74     }
75    
76 loki_val 1.14 # @ECLASS-VARIABLE: TARBALL
77     # @DESCRIPTION:
78     # The GtkSharp modules are currently divided into three seperate tarball
79     # distributions. The TARBALL variable holds the name of the tarball
80     # to which GTK_SHARP_MODULE belongs.
81     case ${GTK_SHARP_MODULE} in
82     glib|glade|gtk|gdk|atk|pango|gtk-dotnet|gtk-gapi|gtk-docs)
83     TARBALL="gtk-sharp"
84     case ${PVR} in
85 loki_val 1.15 2.12.*)
86 loki_val 1.19 SRC_URI="mirror://gentoo/${TARBALL}-2.12.7.patch.bz2"
87 loki_val 1.14 #Upstream: https://bugzilla.novell.com/show_bug.cgi?id=$bugno
88     #Upstream bug #470390 for the gtk-sharp-2.12.7.patch
89 loki_val 1.15 PATCHES=(
90     "${WORKDIR}/${TARBALL}-2.12.7.patch"
91     )
92 loki_val 1.14 EAUTORECONF="YES"
93     add_bdepend "=sys-devel/automake-1.10*"
94     add_bdepend ">=sys-devel/autoconf-2.61"
95     ;;
96     esac
97     ;;
98     art|gnome|gnomevfs|gconf)
99     TARBALL="gnome-sharp"
100     add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
101     has "${GTK_SHARP_MODULE}" "${gapi_users_list}" && \
102     add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
103 loki_val 1.19 case ${PVR} in
104     2.24.1*)
105     SRC_URI="mirror://gentoo/${TARBALL}-2.24.1.patch.bz2"
106 loki_val 1.20 # Upstream bug: https://bugzilla.novell.com/show_bug.cgi?id=483251
107 loki_val 1.19 PATCHES=(
108     "${WORKDIR}/${TARBALL}-2.24.1.patch"
109     )
110     EAUTORECONF="YES"
111     add_bdepend "=sys-devel/automake-1.10*"
112     add_bdepend ">=sys-devel/autoconf-2.61"
113     ;;
114     esac
115 loki_val 1.14 ;;
116     gnome-desktop|gnome-print|gnome-panel|gtkhtml|gtksourceview|nautilusburn|rsvg|vte|wnck)
117     TARBALL="gnome-desktop-sharp"
118     add_depend "=dev-dotnet/gtk-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
119 loki_val 1.21 add_depend "=dev-dotnet/gnome-sharp-2.24*"
120 loki_val 1.14 add_bdepend "=dev-dotnet/gtk-sharp-gapi-${GTK_SHARP_REQUIRED_VERSION}*"
121     ;;
122     *)
123     eerror "Huh? Sonny boy, looks like your GTK_SHARP_MODULE is not on the approved list. BAILING!"
124     die "How did we get here!!?"
125     ;;
126     esac
127 loki_val 1.8
128     case ${PF} in
129     #gtk-sharp tarball
130 loki_val 1.14 gtk-sharp-docs*)
131     add_depend ">=virtual/monodoc-2.0"
132     ;;
133 loki_val 1.8 gtk-sharp-gapi*)
134 loki_val 1.10 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
135 loki_val 1.8 add_depend "dev-perl/XML-LibXML"
136     ;;
137     gtk-sharp-*)
138 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
139     add_depend "~dev-dotnet/glib-sharp-${PV}"
140 loki_val 1.8 add_depend "~dev-dotnet/atk-sharp-${PV}"
141     add_depend "~dev-dotnet/gdk-sharp-${PV}"
142     add_depend "~dev-dotnet/pango-sharp-${PV}"
143     ;;
144     gdk-sharp-*)
145 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
146     add_depend "~dev-dotnet/glib-sharp-${PV}"
147 loki_val 1.8 add_depend "x11-libs/gtk+:2"
148     add_depend "~dev-dotnet/pango-sharp-${PV}"
149 loki_val 1.14 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
150 loki_val 1.8 ;;
151     atk-sharp-*)
152 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
153     add_depend "~dev-dotnet/glib-sharp-${PV}"
154     add_depend "dev-libs/atk"
155 loki_val 1.8 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
156     ;;
157     glib-sharp-*)
158     add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
159     add_depend "dev-libs/glib:2"
160     ;;
161     pango-sharp-*)
162 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
163     add_depend "~dev-dotnet/glib-sharp-${PV}"
164     add_depend "x11-libs/pango"
165 loki_val 1.8 add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
166     ;;
167     gtk-dotnet-*)
168 loki_val 1.14 add_depend "~dev-dotnet/glib-sharp-${PV}"
169 loki_val 1.8 add_depend "~dev-dotnet/gdk-sharp-${PV}"
170     add_depend "~dev-dotnet/pango-sharp-${PV}"
171 loki_val 1.14 add_depend "~dev-dotnet/gtk-sharp-${PV}"
172     add_depend "dev-lang/mono[-minimal]"
173     add_rdepend "!<=dev-dotnet/gtk-sharp-2.12.7:2"
174 loki_val 1.8 ;;
175     glade-sharp-*)
176 loki_val 1.14 add_bdepend "~dev-dotnet/gtk-sharp-gapi-${PV}"
177     add_depend "~dev-dotnet/glib-sharp-${PV}"
178 loki_val 1.8 add_depend "~dev-dotnet/atk-sharp-${PV}"
179     add_depend "~dev-dotnet/gdk-sharp-${PV}"
180 loki_val 1.14 add_depend "~dev-dotnet/gtk-sharp-${PV}"
181 loki_val 1.8 add_depend "~dev-dotnet/pango-sharp-${PV}"
182     add_depend ">=gnome-base/libglade-2.3.6"
183     ;;
184     #gnome-sharp tarball
185     art-sharp-*)
186     add_depend ">=media-libs/libart_lgpl-2.3.20"
187     ;;
188     gnome-sharp-*)
189     add_depend ">=gnome-base/libgnomeui-${PV_MAJOR}"
190     add_depend "~dev-dotnet/gnomevfs-sharp-${PV}"
191     add_depend "~dev-dotnet/art-sharp-${PV}"
192     add_depend ">=gnome-base/libgnomecanvas-${GNOMECANVAS_REQUIRED_VERSION}"
193 loki_val 1.22 add_depend ">=x11-libs/gtk+-2.14.0"
194 loki_val 1.8 ;;
195     gconf-sharp-*)
196     add_depend ">=gnome-base/gconf-${PV_MAJOR}"
197 loki_val 1.21 add_depend "=dev-dotnet/glade-sharp-${GTK_SHARP_REQUIRED_VERSION}*"
198 loki_val 1.8 add_depend "~dev-dotnet/gnome-sharp-${PV}"
199     add_depend "~dev-dotnet/art-sharp-${PV}"
200     ;;
201     gnomevfs-sharp-*)
202     add_depend ">=gnome-base/gnome-vfs-${PV_MAJOR}"
203     ;;
204     #gnome-desktop-sharp tarball
205     gnome-desktop-sharp-*)
206 loki_val 1.25 # NOTE: libgnome-desktop-2.so has been known to make binary-
207     # incompatible changes, requiring .so bumps. gnome-desktop-sharp
208     # is locked to a specific .so.n version, so strict dependencies
209     # may be required in the future (as it has in the past).
210     add_depend ">=gnome-base/gnome-desktop-${PV_MAJOR}"
211 loki_val 1.8 ;;
212     gnome-panel-sharp-*)
213 zmedico 1.17 add_depend ">=gnome-base/gnome-panel-${PV_MAJOR}"
214 loki_val 1.8 ;;
215     gnome-print-sharp-*)
216     add_depend ">=gnome-base/libgnomeprint-${API_VERSION}"
217     ;;
218     gtkhtml-sharp-*)
219     #NOTE: gtkhtml dependency must follow gtkhtml-sharp version.
220     #i.e. gtkhtml-sharp-2.24.0 >=gtkhtml-3.24
221     # gtkhtml-sharp-2.16.0 >=gtkhtml-3.16
222     # See bug 249540 for unpleasant side effects.
223     add_depend ">=gnome-extra/gtkhtml-$(($(get_version_component_range 1) + 1 )).$(get_version_component_range 2)"
224     ;;
225     gtksourceview-sharp-*)
226     add_depend ">=x11-libs/gtksourceview-${GTKSOURCEVIEW_REQUIRED_VERSION}:2.0"
227     ;;
228     nautilusburn-sharp-*)
229 loki_val 1.23 add_depend ">=gnome-extra/nautilus-cd-burner-2.24.0"
230 loki_val 1.8 ;;
231     rsvg-sharp-*)
232     add_depend ">=gnome-base/librsvg-${RSVG_REQUIRED_VERSION}"
233     ;;
234     vte-sharp-*)
235     add_depend ">=x11-libs/vte-${VTE_REQUIRED_VERSION}"
236     ;;
237     wnck-sharp-*)
238     add_depend ">=x11-libs/libwnck-${PV_MAJOR}"
239     ;;
240     esac
241    
242 loki_val 1.14 # @ECLASS-VARIABLE: DESCRIPTION
243     # @DESCRIPTION:
244     # Default value: GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball
245     DESCRIPTION="GtkSharp's ${GTK_SHARP_MODULE} module of the ${TARBALL} tarball"
246     # @ECLASS-VARIABLE: HOMEPAGE
247     # @DESCRIPTION:
248     # Default value: http://www.mono-project.com/GtkSharp
249     HOMEPAGE="http://www.mono-project.com/GtkSharp"
250     # @ECLASS-VARIABLE: DESCRIPTION
251     # @DESCRIPTION:
252     # Default value: LGPL-2.1
253     LICENSE="LGPL-2.1"
254 loki_val 1.8
255 loki_val 1.14 add_depend ">=dev-lang/mono-2.0.1"
256     add_bdepend ">=sys-apps/sed-4"
257     add_bdepend ">=dev-util/pkgconfig-0.23"
258     add_bdepend ">=app-shells/bash-3.1"
259 loki_val 1.8
260 loki_val 1.14 IUSE="debug"
261 loki_val 1.19 # @ECLASS-VARIABLE: S
262 loki_val 1.14 # @DESCRIPTION:
263     # Default value: ${WORKDIR}/${TARBALL}-${PV}
264     S="${WORKDIR}/${TARBALL}-${PV}"
265     # @ECLASS-VARIABLE: SRC_URI
266     # @DESCRIPTION:
267     # Default value: mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2
268     SRC_URI="${SRC_URI}
269     mirror://gnome/sources/${TARBALL}/${PV_MAJOR}/${TARBALL}-${PV}.tar.bz2"
270    
271     # @FUNCTION: get_sharp_apis
272     # @USAGE: <type> <pkgconfig-package>
273     # @RETURN: .NET API files
274     # @DESCRIPTION:
275     # Given a valid pkg-config package, will return a list of API xml files.
276     # <type> can be either --prefixed or --bare. If prefixed, each API file
277     # will be prefixed with -I:
278     get_sharp_apis() {
279     [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
280     get_sharp_assemblies "$@"
281     }
282    
283     # @FUNCTION: get_sharp_assemblies
284     # @USAGE: <type> <pkgconfig-package>
285     # @RETURN: .NET .dll assemblies
286     # @DESCRIPTION:
287     # Given a valid pkg-config package, will return a list of .dll assemblies.
288     # <type> can be either --prefixed or --bare. If prefixed, each .dll file
289     # will be prefixed with -r:
290     get_sharp_assemblies() {
291     [[ ${#@} -eq 2 ]] || die "${FUNCNAME} needs two arguments"
292     local string config=libs prefix="-r:"
293     local -a rvalue
294     [[ "${FUNCNAME[1]}" = "get_sharp_apis" ]] && config=cflags && prefix="-I:"
295     for string in $(pkg-config --${config} ${2} 2> /dev/null)
296 loki_val 1.8 do
297 loki_val 1.14 rvalue+=( ${string#-?:} )
298 loki_val 1.8 done
299 loki_val 1.14
300     case $1 in
301     --bare)
302     :
303     ;;
304     --prefixed)
305     for (( i=0 ; i< ${#rvalue[@]} ; i++ ))
306     do
307     rvalue[$i]=${prefix}${rvalue[$i]}
308     done
309     ;;
310     *)
311     die "${FUNCNAME}: Unknown parameter"
312     ;;
313     esac
314     echo "${rvalue[@]}"
315     }
316    
317     # @FUNCTION: phase_hook
318     # @USAGE: <prefix>
319     # Looks for functions named <prefix>_caller_suffix and executes them.
320     # _caller_suffix is the calling function with the prefix
321     # gtk-sharp-module removed.
322     phase_hook() {
323     [[ ${#@} -eq 1 ]] || die "${FUNCNAME} needs one argument"
324     if [[ "$(type -t ${1}${FUNCNAME[1]#gtk-sharp-module})" = "function" ]]
325     then
326     ebegin "Phase-hook: Running ${1}${FUNCNAME[1]#gtk-sharp-module}"
327     ${1}${FUNCNAME[1]#gtk-sharp-module}
328     eend 0
329     fi
330 loki_val 1.8 }
331    
332 loki_val 1.14 # @FUNCTION: ac_path_prog_override
333     # @USAGE: <PROG> [path]
334     # @DESCRIPTION:
335     # Override AC_PATH_PROG() autoconf macros. Path will be set to " " if
336     # not specified.
337     ac_path_prog_override() {
338     if [[ ${#@} -lt 1 || ${#@} -gt 2 ]]
339 loki_val 1.8 then
340 loki_val 1.14 eerror "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
341     eerror "AC_PATH_PROG(PARAM1, param2)"
342     die "${FUNCNAME[0]} requires at least one parameter and takes at most two:"
343 loki_val 1.8 fi
344 loki_val 1.14 export ac_cv_path_${1}="${2:- }"
345 loki_val 1.8 }
346    
347 loki_val 1.14
348     # @FUNCTION: pkg_check_modules_override
349     # @USAGE: <GROUP> [package1] [package2]
350     # @DESCRIPTION:
351     # Will export the appropriate variables to override PKG_CHECK_MODULES autoconf
352     # macros, with the string " " by default. If packages are specified, they will
353     # be looked up with pkg-config and the appropriate LIBS and CFLAGS substituted.
354     # LIBS and CFLAGS can also be specified per-package with the following syntax:
355     # @CODE
356     # package=LIBS%CFLAGS
357     # @CODE
358     # = and % have no effect unless both are specified.
359     # Here is an example:
360     # @CODE
361     # pkg_check_modules_override GASH "gtk+-2.0=-jule%" gobject-2.0
362     # @CODE
363     # The above example will do:
364     # export GASH_CFLAGS+=" -jule"
365     # export GASH_LIBS+=" "
366     # export GASH_CFLAGS+=" $(pkg-config --cflags gobject-2.0)"
367     # export GASH_LIBS+=" $(pkg-config --libs gobject-2.0)"
368     #
369     # NOTE: If a package is not found, the string " " will be inserted in place of
370     # <GROUP>_CFLAGS and <GROUP>_LIBS
371     pkg_check_modules_override() {
372     local package
373     local group="${1}"
374     local packages="${*:2}"
375     export ${group}_CFLAGS=" "
376     export ${group}_LIBS=" "
377    
378     if [[ ${#@} -lt 1 ]]
379 loki_val 1.8 then
380 loki_val 1.14 eerror "${FUNCNAME[0]} requires at least one parameter: GROUP"
381     eerror "PKG_CHECK_MODULES(GROUP, package1 package2 etc)"
382     die "${FUNCNAME[0]} requires at least one parameter: GROUP"
383 loki_val 1.8 fi
384 loki_val 1.1
385 loki_val 1.14 for package in $packages
386     do
387     if [[ ${package/=} != ${package} && ${package/\%} != ${package} ]]
388     then
389     package_cflag_libs=${package##*=}
390     export ${group}_CFLAGS+=" ${package_cflag_libs%%\%*}"
391     export ${group}_LIBS+=" ${package_cflag_libs##*\%}"
392     else
393     if pkg-config --exists $package
394     then
395     export ${group}_CFLAGS+=" $(pkg-config --cflags $package)"
396     export ${group}_LIBS+=" $(pkg-config --libs $package)"
397     else
398     export ${group}_CFLAGS+=" "
399     export ${group}_LIBS+=" "
400     fi
401     fi
402     done
403     }
404 loki_val 1.1
405 loki_val 1.14 # @FUNCTION: gtk-sharp-tarball-post_src_prepare
406     # @DESCRIPTION:
407     # Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
408     # local assemblies to the installed ones. Is only called by src_prepare when
409     # $GTK_SHARP_MODULE is a member of $gtk_sharp_module_list.
410     gtk-sharp-tarball-post_src_prepare() {
411 loki_val 1.6 cd "${S}/${GTK_SHARP_MODULE_DIR}"
412 loki_val 1.14 sed -i \
413     -e "s; \$(srcdir)/../glib/glib-api.xml; $(get_sharp_apis --bare glib-sharp-2.0);" \
414     -e "s; ../pango/pango-api.xml; $(get_sharp_apis --bare pango-sharp-2.0);" \
415     -e "s; ../atk/atk-api.xml; $(get_sharp_apis --bare atk-sharp-2.0);" \
416     -e "s; ../gdk/gdk-api.xml; $(get_sharp_apis --bare gdk-sharp-2.0);" \
417     -e "s; ../gtk/gtk-api.xml; $(get_sharp_apis --bare gtk-sharp-2.0);" \
418     -e "s; \.\./glib/glib-sharp.dll; $(get_sharp_assemblies --bare glib-sharp-2.0);g" \
419     -e "s; \.\./pango/pango-sharp.dll; $(get_sharp_assemblies --bare pango-sharp-2.0);g" \
420     -e "s; \.\./atk/atk-sharp.dll; $(get_sharp_assemblies --bare atk-sharp-2.0);g" \
421     -e "s; \.\./gdk/gdk-sharp.dll; $(get_sharp_assemblies --bare gdk-sharp-2.0);g" \
422     -e "s; \.\./gtk/gtk-sharp.dll; $(get_sharp_assemblies --bare gtk-sharp-2.0);g" \
423     -e "s;\$(RUNTIME) \$(top_builddir)/parser/gapi-fixup.exe;/usr/bin/gapi2-fixup;" \
424     -e "s;\$(RUNTIME) \$(top_builddir)/generator/gapi_codegen.exe;/usr/bin/gapi2-codegen;" \
425     -e "s:\$(SYMBOLS) \$(top_builddir)/parser/gapi-fixup.exe:\$(SYMBOLS):" \
426     -e "s:\$(INCLUDE_API) \$(top_builddir)/generator/gapi_codegen.exe:\$(INCLUDE_API):" \
427     $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
428     }
429    
430     # @FUNCTION: gnome-sharp-tarball-post_src_prepare
431     # @DESCRIPTION:
432     # Runs a M-m-m-monster sed on GTK_SHARP_MODULE_DIR to convert references to
433     # local assemblies to the installed ones. Is only called by src_prepare when
434     # $GTK_SHARP_MODULE is a member of $gnome_sharp_module_list.
435     gnome-sharp-tarball-post_src_prepare() {
436     cd "${S}/${GTK_SHARP_MODULE_DIR}"
437     sed -i \
438     -e "s; ../gnomevfs/gnome-vfs-api.xml; $(get_sharp_apis --bare gnome-vfs-sharp-2.0);" \
439     -e "s; ../art/art-api.xml; $(get_sharp_apis --bare art-sharp-2.0);" \
440     -e "s; \.\./art/art-sharp.dll; $(get_sharp_assemblies --bare art-sharp-2.0);g" \
441     -e "s; \.\./gnomevfs/gnome-vfs-sharp.dll; $(get_sharp_assemblies --bare gnome-vfs-sharp-2.0);g" \
442     -e "s;/r:\$(top_builddir)/art/art-sharp.dll;$(get_sharp_assemblies --prefixed art-sharp-2.0);" \
443     -e "s;/r:\$(top_builddir)/gnome/gnome-sharp.dll;$(get_sharp_assemblies --prefixed gnome-sharp-2.0);" \
444     $(find . -name Makefile.in) || die "failed to fix ${TARBALL}-tarball makefiles"
445     }
446    
447     # @FUNCTION: gtk-sharp-module_src_prepare
448     # @DESCRIPTION:
449     # Runs autopatch from base.eclass, eautoreconf if EAUTORECONF is set to any
450     # value.
451     # Contains a phase_hook, runs very last.
452     # phase_hook prefix trigger: ${TARBALL}-tarball-post
453     # Is exported.
454     gtk-sharp-module_src_prepare() {
455     base_src_util autopatch
456     # @ECLASS-VARIABLE: EAUTORECONF
457     # @DESCRIPTION:
458     # If set, EAUTORECONF will be run during src_prepare.
459     [[ ${EAUTORECONF} ]] && eautoreconf
460     phase_hook ${TARBALL}-tarball-post
461 loki_val 1.24 elibtoolize
462 loki_val 1.1 }
463    
464 loki_val 1.14 # @FUNCTION: gtk-sharp-tarball_src_configure
465     # @DESCRIPTION:
466     # Sets some environment variables that will allow us to make the dependencies
467     # for each ebuild be only its own dependencies, without patching configure.
468     # Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
469     # is a member of $gtk_sharp_module_list.
470     gtk-sharp-tarball_src_configure() {
471     pkg_check_modules_override GLIB gobject-2.0
472     pkg_check_modules_override GIO gio-2.0
473     pkg_check_modules_override PANGO pango
474     pkg_check_modules_override ATK atk
475     pkg_check_modules_override GTK gtk+-2.0
476     pkg_check_modules_override GLADE libglade-2.0
477     }
478    
479     # @FUNCTION: gnome-sharp-tarball_src_configure
480     # @DESCRIPTION:
481     # Sets some environment variables that will allow us to make the dependencies
482     # for each ebuild be only its own dependencies. Without patching configure.
483     # Is only called by gtk-sharp-module_src_configure when $GTK_SHARP_MODULE
484     # is a member of $gnome_sharp_module_list.
485     gnome-sharp-tarball_src_configure() {
486     pkg_check_modules_override GLADESHARP glade-sharp-2.0
487     pkg_check_modules_override GAPI gapi-2.0
488     ac_path_prog_override GAPI_PARSER /usr/bin/gapi2-parser
489     ac_path_prog_override GAPI_CODEGEN /usr/bin/gapi2-codegen
490     ac_path_prog_override GAPI_FIXUP /usr/bin/gapi2-fixup
491     }
492    
493     # @FUNCTION: gtk-sharp-module_src_configure
494     # @USAGE: [econf-arguments]
495     # @DESCRIPTION:
496     # Calls econf with some default values.
497     # Contains a phase_hook, run before econf.
498     # phase_hook prefix trigger: ${TARBALL}-tarball
499     # Is exported.
500 loki_val 1.1 gtk-sharp-module_src_configure() {
501 loki_val 1.14 phase_hook ${TARBALL}-tarball
502 loki_val 1.8 econf --disable-static \
503     --disable-dependency-tracking \
504     --disable-maintainer-mode \
505     $(use debug &&echo "--enable-debug" ) \
506     ${@} || die "econf failed"
507 loki_val 1.1 }
508    
509 loki_val 1.14 # @FUNCTION: gtk-sharp-module_src_compile
510     # @DESCRIPTION:
511     # Calls emake in the subdir of the module.
512     # Sets CSC=/usr/bin/gmcs. Deletes top_srcdir Makefiles to prevent recursing in
513     # case we missed some dll references.
514     # Is exported.
515 loki_val 1.1 gtk-sharp-module_src_compile() {
516 loki_val 1.14 rm -f "${S}"/Makefile* &> /dev/null
517 loki_val 1.6 cd "${S}/${GTK_SHARP_MODULE_DIR}"
518 loki_val 1.14 emake CSC=/usr/bin/gmcs || die "emake failed"
519 loki_val 1.1 }
520    
521 loki_val 1.14 # @FUNCTION: gtk-sharp-module_src_install
522     # @DESCRIPTION:
523     # Installs the module. Fixes up lib paths so they're multilib-safe.
524     # Gets rid of .la files.
525     # Is exported.
526 loki_val 1.1 gtk-sharp-module_src_install() {
527 loki_val 1.12 cd "${S}/${GTK_SHARP_MODULE_DIR}"
528 loki_val 1.14 emake DESTDIR="${D}" install || die "emake install failed"
529 loki_val 1.8 mono_multilib_comply
530 loki_val 1.14 find "${D}" -type f -name '*.la' -exec rm -rf '{}' '+' || die "la removal failed"
531     [[ $(find "${D}" -type f|wc -l) -lt 3 ]] && die "Too few files. This smells like a failed install."
532 loki_val 1.1 }
533    
534     EXPORT_FUNCTIONS src_prepare src_configure src_compile src_install

  ViewVC Help
Powered by ViewVC 1.1.20